<template>
  <a-spin :spinning="loading">
    <li class="title"><h1>赛事日历</h1></li>
    <FilterSettings @filterSettingsChange="onChangeFilterParams"></FilterSettings>
    <a-calendar style="margin-bottom: 60px" v-model="calendarDate" @panelChange="onPanelChange">
      <ul slot="dateCellRender" slot-scope="value" class="events">
        <div v-for="item in getListData(value)" :key="item.game_id">
          <li v-if="item.checked==1">
            <a-popover :title=item.game_name trigger="click" placement="bottomLeft"
                        :overlayStyle="{maxWidth: '500px'}">
              <div slot="content" class="popover-content">
                <p v-if="item.platform"><span>平&emsp;&emsp;台：</span>{{ item.platform }}</p>
                <p><span>开始时间：</span>{{ item.game_start_time }}</p>
                <p v-if="item.game_end_time"><span>结束时间：</span>{{ item.game_end_time }}</p>
                <p v-if="item.duration"><span>时&emsp;&emsp;长：</span>{{ item.duration + ':00' }}</p>
                <p><span>难&emsp;&emsp;度：</span>{{ item.level == 1 ? '简单' : item.level == 2 ? '中等' : '困难' }}</p>
                <p>
                  <span>链&emsp;&emsp;接：</span>
                  <a style="flex: 1" :href=item.website target="_blank">{{ item.website }}</a>
                </p>
                <p :style="item | degreeVisible(that)" style="align-items: center">
                  <span>推荐指数：</span>
                  <a-rate :default-value="item | degree" disabled/>
                </p>
                <a-button v-if="!item.reserved"
                          type="primary"
                          :loading="reserveLoading"
                          @click="ReserveGame(item.game_id, 'add')">预约</a-button>
                <a-button v-else type="primary"
                          :loading="reserveLoading"
                          @click="ReserveGame(item.game_id, 'delete')">取消预约</a-button>
              </div>
              <p class="game-block" :style="item | style(that)">{{ item.game_name }}</p>
            </a-popover>
          </li>
        </div>
      </ul>
    </a-calendar>
  </a-spin>
</template>

<script>
import moment from 'moment';
import FilterSettings from './FilterSettings.vue'
export default {
  components: {FilterSettings},
  data() {
    return {
      that: this,
      matches: [],
      cust_matches: [],
      modal_visible: false,
      calendarDate: this.$moment(),
      searchForm: {
        start_time: '',
        end_time: '',
        reserved: true,
        subscribed: true,
        recommended: true,
        other: true,
        duration: 'all',
        level: 'all'
      },
      game_list: [],
      loading: false,
      reserveLoading: false
    }
  },

  filters: {

    degreeVisible(item, that) {
      if (that.searchForm.reserved && item.reserved) return 'display: none';
      if (that.searchForm.subscribed && item.subscribed) return 'display: none';
      if (that.searchForm.recommended && item.recommended) return '';
      if (that.searchForm.other && item.other) return 'display: none';
      return 'display: none';
    },

    degree(item) {
      switch (item.recommend_degree) {
        case 33: return 1;
        case 67: return 3;
        case 100: return 5;
        default: return 0
      }
    },

    style(item, that) {
      if (that.searchForm.reserved && item.reserved) return 'background: #ff3434;';
      if (that.searchForm.subscribed && item.subscribed) return 'background: #2aa8ec;';
      if (that.searchForm.recommended && item.recommended) return `background: rgba(153,51,153, ${item.recommend_degree}%)`;
      if (that.searchForm.other && item.other) return 'background: #517E55;';
      return ''
    }
  },
  //挂载阶段获取预约、订阅、比赛信息
  mounted: function () {
    this.getGamesList()
  },
  methods: {
    moment,

    async getGamesList(params = {}) {
      this.loading = !params.noLoading
      var date = new Date();
      var year = date.getFullYear();
      var month = date.getMonth() + 1;
      var default_start_time = year + "-" + month + "-01 00:00:00";
      var default_end_time = year + "-" + (month + 1) + "-01 00:00:00";
      await this.$axios.get('game/query', {
        start_time: this.searchForm.start_time == '' ? default_start_time : this.searchForm.start_time,
        end_time: this.searchForm.end_time == '' ? default_end_time : this.searchForm.end_time,
      }).then((res) => {
        if (res.code == undefined) {
          this.game_list = res
          this.filterGamesList()
        }
      }).catch(() => {
      });
      this.loading = false
    },

    filterGamesList() {
      this.matches = this.game_list.filter(item => {
        let reserveFlag = this.searchForm.reserved ? item.reserved : false
        let subscribeFlag = this.searchForm.subscribed ? item.subscribed : false
        let recommendFlag = this.searchForm.recommended ? item.recommended : false
        let otherFlag = this.searchForm.other ? item.other : false
        let flag = reserveFlag || subscribeFlag || recommendFlag || otherFlag;
        if (flag) {
          let diffTime = 0
          let flag1 = true
          let flag2 = true
          if (item.game_end_time) {
            diffTime = this.$moment(item.game_end_time).diff(this.$moment(item.game_start_time))
          } else if (item.duration) {
            diffTime = this.$moment.duration(`${item.duration}:00`).as('seconds') * 1000
          }
          if (this.searchForm.duration == '1') {
            flag1 = diffTime < 60 * 60 * 1000
          } else if (this.searchForm.duration == '2') {
            flag1 = diffTime < 3 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '3') {
            flag1 = diffTime < 8 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '4') {
            flag1 = diffTime < 24 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '5') {
            flag1 = diffTime >= 24 * 60 * 60 * 1000
          }
          if (this.searchForm.level == 'all') {
            flag2 = true
          } else {
            flag2 = this.searchForm.level == item.level
          }
          return flag1 && flag2
        } else {
          return false
        }
      })
    },
    onChangeFilterParams(data) {
      this.searchForm[data.index] = data.val
      this.filterGamesList(this.matches)
    },
    async ReserveGame(game_id, action) {
      this.reserveLoading = true
      await this.$axios.post("reserve/" + action, {
        game_id: game_id,
      }).then((res) => {
        if (res.code == 0) {
          this.getGamesList({noLoading: true})
          this.$message.success('操作成功')
        } else {
          this.$message.error('操作失败')
        }
      }).catch(() => {
        this.$message.error('操作失败')
      })
      this.reserveLoading = false
    },
    //日历格渲染函数
    getListData(value) {
      let listData = [];
      for (var record of this.matches) {
        let startMonth = new Date(record.game_start_time).getMonth() + 1;
        let startDay = new Date(record.game_start_time).getDate();
        if (value.month() + 1 == startMonth && value.date() == startDay) {
          listData.push(record)
        }
      }
      return listData;
    },
    /*比赛时间段选择事件*/
    onPanelChange(value) {
      this.searchForm.start_time = value.year() + "-" + (value.month() + 1) + "-01 00:00:00"
      this.searchForm.end_time = value.year() + "-" + (value.month() + 2) + "-01 00:00:00"
      this.getGamesList()
      this.calendarDate = value
    }
  },
};
</script>
<style lang="less" scoped>
.title {
    border-left: 5px solid #517E55;
    padding-left: 20px;
    height: 30px;
    margin: 20px 0;
    font-weight: bold;
    vertical-align: baseline;

    h1 {
      line-height: 28px;
    }
}

.events {
  list-style: none;
  margin: 0;
  padding: 0;
}

.popover-content {
  p {
    display: flex;
    span {
      width: 75px;
    }
    a {
      word-break: break-all;
    }
  }
}

.events .ant-badge-status {
  overflow: hidden;
  white-space: nowrap;
  width: 100%;
  text-overflow: ellipsis;
  font-size: 12px;
}

li {
  margin: 5px;
}

li::marker {
  content: '';
}

/deep/ .ant-fullcalendar-fullscreen {
  .ant-fullcalendar-header {
    padding: 20px;
    text-align: center;
  }

  .ant-radio-group {
    display: none;
  }

  .ant-fullcalendar-date {
    position: relative;
    padding: 0;

    .ant-fullcalendar-value {
      position: absolute;
      right: 0;
    }

    .ant-fullcalendar-content {
      height: 100%;
    }
  }

  .game-block {
    width: 130px;
    box-sizing: border-box;
    padding: 3px 5px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    color: #ffffff;
    font-size: 12px;
    border-radius: 3px;
  }
}
</style>